local name = ...
local unitBar = Dominos[name]
local pieces = {}


function unitBar:Load()
	self.components = self.components or {}
	if #self.components == 0 then
		for i, info in pairs(pieces) do
			local component, key = info.func(self), info.id
			component.key = key
			if component.defaults then
				self.sets[key] = self.sets[key] or {}
				self.check(component.defaults, self.sets[key])
				component.sets = self.sets[key]
				self[key] = component
			end
			tinsert(self.components, component)
		end
	end
	for id, component in pairs(self.components) do
		if component.Load then
			component:Load()
		end
	end
end

function unitBar:AddPart(id, func)
	tinsert(pieces, {id = id, func = func})
end

function unitBar:UpdateComponents()
	if self.components then
		for id, component in pairs(self.components) do
			if component.Layout then
				component:Layout()
			end
		end
	end
end