local AddonName = "Dominos"
local Addon = LibStub('AceAddon-3.0'):GetAddon(AddonName)

local UnitMenu = Addon:CreateClass('Button')
Addon.UnitMenu = UnitMenu

function UnitMenu:New(parent)
	local name = ('%s_%s_UnitMenu'):format(AddonName, parent.id)
	if _G[name] then
		return _G[name]
	end
	local button = self:Bind(CreateFrame('Frame', ('%s_%s_UnitMenu'):format(AddonName, parent.id), parent.box, 'UIDropDownMenuTemplate'))
	if button then
		button.owner = parent
	end
	return button
end

local taints = {
	SET_FOCUS = 1,
	CLEAR_FOCUS = 1,
	MOVE_FOCUS_FRAME = 1,
	LARGE_FOCUS = 1,
	MOVE_PLAYER_FRAME = 1,
	MOVE_TARGET_FRAME = 1,
}

local function remove(menu)
	UnitPopupMenus["_"..menu] = CopyTable(UnitPopupMenus[menu])
	for i, b in pairs(UnitPopupMenus["_"..menu]) do
		if taints[b] then
			tremove(UnitPopupMenus["_"..menu], i)
		end
	end
end

function UnitMenu:Initialize()
	local menu
	local name
	local unit = self.id
	local id = nil
	if ( UnitIsUnit(unit, "player") ) then
		menu = "SELF"
	elseif ( UnitIsUnit(unit, "vehicle") ) then
		menu = "VEHICLE"
	elseif ( UnitIsUnit(unit, "pet") ) then
		menu = "PET"
	elseif ( UnitIsOtherPlayersBattlePet(unit) ) then
		menu = "OTHERBATTLEPET"
	elseif ( UnitIsBattlePet(unit) ) then
		menu = "BATTLEPET"
	elseif ( UnitIsOtherPlayersPet(unit) ) then
		menu = "OTHERPET"	
	elseif ( UnitIsPlayer(unit) ) then
		id = UnitInRaid(unit)
		if ( id ) then
			menu = "RAID_PLAYER"
		elseif ( UnitInParty(unit) ) then
			menu = "PARTY"
		else
			menu = "PLAYER"
		end
	else
		menu = "TARGET"
		name = RAID_TARGET_ICON
	end
	if ( menu ) then
		remove(menu)
		return UnitPopup_ShowMenu(self, "_"..menu, unit, name, id)
	end
end

function UnitMenu:Load()
	self.id = self.owner.id
	self.owner.box.dropDown = self
	self.owner.box:SetAttribute("*type1", "target")
	self.owner.box:SetAttribute("*type2", "menu")
	self.owner.box:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	if self.Initialize then
		CompactUnitFrame_SetMenuFunc(self:GetParent(), self.Initialize)
	end
end

local unitBar = Dominos[...]

unitBar:AddPart("drop", function(parent)
	return UnitMenu:New(parent)
end)
